IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'GERA_CODIGOBARRA_FECHAOP' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION GERA_CODIGOBARRA_FECHAOP
GO
CREATE FUNCTION GERA_CODIGOBARRA_FECHAOP(
   @P_CDFILIAL     IN VARCHAR(04),
   @P_CDPRODUTO    IN VARCHAR(10),
   @P_NRLOTEESTQ   IN VARCHAR(20),
   @P_NRSUBLOTE    IN VARCHAR(04),
   @P_QTDE         IN DOUBLE PRECISION) RETURNS VARCHAR
AS
BEGIN
   DECLARE @V_IDTIPOPRODPAR VARCHAR(01);
   DECLARE @V_IDUTQTCODBARRA VARCHAR(01);
   DECLARE @V_QTNUMEROINT DOUBLE PRECISION;
   DECLARE @V_QTNUMERODEC DOUBLE PRECISION;
   DECLARE @V_IDTPSEPARADOR VARCHAR(01);
   DECLARE @V_IDUTALLCCODBARRA VARCHAR(01);
   DECLARE @V_QTTAMALMOX DOUBLE PRECISION;
   DECLARE @V_QTTAMLOCAL DOUBLE PRECISION;
   DECLARE @V_IDUTLTSUBCODBAR VARCHAR(01);
   DECLARE @V_QTTAMLOTE DOUBLE PRECISION;
   DECLARE @V_QTTAMSUBLOTE DOUBLE PRECISION;
   DECLARE @V_QTTAMCDBARRA DOUBLE PRECISION;
   DECLARE @V_IDFILIPADIMPEST VARCHAR(01);
   DECLARE @V_CDPRODUTO       VARCHAR(30);
   DECLARE @V_IDUTILALMOX     VARCHAR(01);
   DECLARE @V_IDUTILLCESTQ    VARCHAR(01);
   DECLARE @V_IDUTILLOTE      VARCHAR(01);
   DECLARE @V_CDALMOX         VARCHAR(06);
   DECLARE @V_CDALMOXARIFADO  VARCHAR(06);
   DECLARE @V_LOCAL           VARCHAR(06);
   DECLARE @V_CDLOCALESTOQ      VARCHAR(06);
   DECLARE @V_LOTE            VARCHAR(20);
   DECLARE @V_SUBLOTE         VARCHAR(04);
   DECLARE @STQTDE            VARCHAR(100);
   DECLARE @V_RESULT          VARCHAR(500);



   SELECT @V_IDTIPOPRODPAR = ISNULL(MAX(IDTIPOPRODPAR),'C') AS IDTIPOPRODPAR,
          @V_IDUTQTCODBARRA = ISNULL(MAX(IDUTQTCODBARRA), 'S') AS IDUTQTCODBARRA,
          @V_QTNUMEROINT = ISNULL(MAX(QTNUMEROINT), 10) AS QTNUMEROINT,
          @V_QTNUMERODEC = ISNULL(MAX(QTNUMERODEC), 5) QTNUMERODEC,
          @V_IDTPSEPARADOR = ISNULL(MAX(IDTPSEPARADOR), '2') IDTPSEPARADOR,
          @V_IDUTALLCCODBARRA = ISNULL(MAX(IDUTALLCCODBARRA), 'S') AS IDUTALLCCODBARRA,
          @V_QTTAMALMOX = ISNULL(MAX(QTTAMALMOX), 6) AS QTTAMALMOX,
          @V_QTTAMLOCAL = ISNULL(MAX(QTTAMLOCAL), 6) AS QTTAMLOCAL,
          @V_IDUTLTSUBCODBAR = ISNULL(MAX(IDUTLTSUBCODBAR), 'S') AS IDUTLTSUBCODBAR,
          @V_QTTAMLOTE = ISNULL(MAX(QTTAMLOTE), 20) AS QTTAMLOTE,
          @V_QTTAMSUBLOTE = ISNULL(MAX(QTTAMSUBLOTE), 4) AS QTTAMSUBLOTE,
          @V_QTTAMCDBARRA = ISNULL(MAX(QTTAMCDBARRA),30) AS QTTAMCDBARRA,
          @V_IDFILIPADIMPEST = ISNULL(MAX(IDFILIPADIMPEST),'N') AS IDFILIPADIMPEST
     FROM PARAMIMPEST P
    WHERE (CDFILPARIMPEST  = @P_CDFILIAL);

   IF (@V_IDTIPOPRODPAR = 'C') BEGIN --Cdigo do produto
      SET @V_CDPRODUTO = @P_CDPRODUTO;
   END
   ELSE IF (@V_IDTIPOPRODPAR = 'B') BEGIN --Cdigo de barras
      SELECT @V_CDPRODUTO = MAX(CDBARPRODUTO)
        FROM PRODUTO
       WHERE CDPRODUTO = @P_CDPRODUTO;

       SET @V_CDPRODUTO = SUBSTRING(@V_CDPRODUTO, 1, @V_QTTAMCDBARRA);
   END
   ELSE IF (@V_IDTIPOPRODPAR = 'E') BEGIN
      SELECT @V_CDPRODUTO = MAX(CDPRODESTO)
        FROM PRODUTO
       WHERE CDPRODUTO = @P_CDPRODUTO;
   END
   ELSE BEGIN
      SELECT @V_CDPRODUTO = MAX(CDARVPROD)
        FROM PRODUTO
       WHERE CDPRODUTO = @P_CDPRODUTO;
   END;

   SELECT @V_IDUTILALMOX = MAX(IDUTILALMOX), @V_IDUTILLCESTQ = MAX(IDUTILLCESTQ), @V_IDUTILLOTE = MAX(IDUTILLOTE)
     FROM PARAMFILIAL
    WHERE CDFILIAL = @P_CDFILIAL;

   IF (@V_IDUTALLCCODBARRA = 'S') BEGIN
      IF (@V_IDUTILALMOX = 'S') BEGIN
         SELECT @V_CDALMOXARIFADO = MAX(CDALMOXPRACA)
           FROM PRODFILI
          WHERE CDFILIAL = @P_CDFILIAL
            AND CDPRODUTO = @P_CDPRODUTO;

         SET @V_CDALMOX = SUBSTRING(LPAD(@V_CDALMOXARIFADO, @V_QTTAMALMOX, '0'),1,@V_QTTAMALMOX);
      END
      ELSE BEGIN
         SET @V_CDALMOX = '';
      END;

      IF (@V_IDUTILLCESTQ = 'S') BEGIN
         SELECT @V_CDLOCALESTOQ = MAX(CDLOCALPRACA)
           FROM PRODFILI
          WHERE CDFILIAL = @P_CDFILIAL
            AND CDPRODUTO = @P_CDPRODUTO;

         SET @V_LOCAL = SUBSTRING(LPAD(@V_CDLOCALESTOQ, @V_QTTAMLOCAL, '0'),1,@V_QTTAMLOCAL);
      END
      ELSE BEGIN
         SET @V_LOCAL = '';
      END;
   END
   ELSE BEGIN
      SET @V_CDALMOX = '';
      SET @V_LOCAL = '';
   END;

   IF (@V_IDUTLTSUBCODBAR = 'S') BEGIN
      IF (@V_IDUTILLOTE = 'S') BEGIN
         SET @V_LOTE := SUBSTRING(LPAD(@P_NRLOTEESTQ, @V_QTTAMLOTE, '0'),1,@V_QTTAMLOTE);
         SET @V_SUBLOTE := SUBSTRING(LPAD(@P_NRSUBLOTE, @V_QTTAMSUBLOTE, '0'),1,@V_QTTAMSUBLOTE);
      END
      ELSE BEGIN
         SET @V_LOTE = '';
         SET @V_SUBLOTE = '';
      END;
   END
   ELSE BEGIN
      SET @V_LOTE = '';
      SET @V_SUBLOTE = '';
   END;

   IF (@V_IDUTQTCODBARRA = 'S') BEGIN
      SET @STQTDE = SUBSTRING(LPAD(TO_CHAR(ROUND(@P_QTDE, @V_QTNUMERODEC) * POWER(10, @V_QTNUMEROINT)), (@V_QTNUMERODEC+@V_QTNUMEROINT), '0'), 1,(@V_QTNUMERODEC+@V_QTNUMEROINT));
   END
   ELSE BEGIN
      @STQTDE = '';
   END;
   SET @V_RESULT = (@V_CDPRODUTO+@V_CDALMOX+@V_LOCAL+@V_LOTE+@V_SUBLOTE+@STQTDE);
   RETURN(@V_RESULT);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_CODIGOBARRA_FECHAOP','6.05.000';
GO
